diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 0f22991d0..8e7cf0baa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -19,6 +19,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.util.helper.*;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
@@ -37,19 +38,30 @@ import java.util.List;
 import java.util.Random;
 
 public abstract class Entity
-    implements IVehicle {
+        implements IVehicle {
+
+    // Util
+    protected @NotNull Random random = new Random();
+    public @NotNull World world;
+
     public static final int DATA_SHARED_FLAGS_ID = 0;
     public static final int FLAG_ONFIRE = 0;
     public static final int FLAG_SNEAKING = 1;
     public static final int FLAG_RIDING = 2;
     public static final int FLAG_SPRINTING = 3;
+
+    // Misc/IDK
+    public boolean slide = true;
+    public boolean removed = false;
+    public boolean hadNicknameSet;
+    public boolean blocksBuilding = false;
+    public double viewScale = 1.0D;
     private static int entityCounter = 0;
     public int id = entityCounter++;
-    public double viewScale = 1.0D;
-    public boolean blocksBuilding = false;
     public @Nullable Entity passenger;
-    public @Nullable IVehicle vehicle;
-    public @NotNull World world;
+    private int soundCooldown;
+
+    // Position
     public double xo;
     public double yo;
     public double zo;
@@ -63,60 +75,89 @@ public abstract class Entity
     public float xRot;
     public float yRotO;
     public float xRotO;
-    public float pushTime;
-    public int pushesThisTick;
+    public int serverPosX;
+    public int serverPosY;
+    public int serverPosZ;
+    private final @NotNull TilePos workingPos1 = new TilePos();
+    private final @NotNull TilePos workingPos2 = new TilePos();
+
+    // Collision/Hitbox
     public final @NotNull AABBd bb = new AABBd();
-    public boolean onGround = false;
-    public boolean horizontalCollision;
-    public boolean verticalCollision;
-    public boolean collision = false;
-    public boolean hurtMarked = false;
-    public boolean hadNicknameSet;
-    public boolean stuckInCobweb;
-    public boolean stuckInSpikes;
-    public boolean slide = true;
-    public boolean removed = false;
     public float heightOffset = 0.0F;
     public float bbWidth = 0.6F;
     public float bbHeight = 1.825F;
+    public boolean horizontalCollision;
+    public boolean verticalCollision;
+    public boolean collision = false;
+    public boolean onGround = false;
+    private final @NotNull AABBd workingBox1 = new AABBd();
+    private final @NotNull AABBd workingBox2 = new AABBd();
+    private final @NotNull AABBd workingBox3 = new AABBd();
+    private final @NotNull AABBd workingBox4 = new AABBd();
+
+    // Movement/Physics
+    public boolean noPhysics = false;
+    public float pushthrough = 0.0F;
     public float walkDistO = 0.0F;
     public float walkDist = 0.0F;
     public float fallDistance = 0.0F;
     private int nextStep = 1;
     public float ySlideOffset = 0.0F;
-    public float footSize = 0.0F;
-    public boolean noPhysics = false;
-    public float pushthrough = 0.0F;
-    protected @NotNull Random random = new Random();
-    public int tickCount;
+    public boolean stuckInCobweb;
+    public boolean stuckInSpikes;
+    public float pushTime;
+    public int pushesThisTick;
+    public int acidJumpCooldown = 0;
+
+    // Vehicle
+    public @Nullable IVehicle vehicle;
+    private double entityRiderPitchDelta;
+    private double entityRiderYawDelta;
+    public boolean turnWithVehicle = true;
+
+    // Damage
+    public int heartsFlashTime = 0;
+    public boolean hurtMarked = false;
+
+    // Water
+    public int airSupply = 300;
+    protected int airMaxSupply = 300;
+    protected boolean wasInWater = false;
+
+    // Fire
+    public static final int FIRE_DAMAGE_INTERVAL_TICKS = 20;
     public int fireImmuneTicks = 1;
     public int remainingFireTicks = 0;
     public int maxFireTicks;
-    private int soundCooldown;
-    protected int airMaxSupply = 300;
-    protected boolean wasInWater = false;
-    public int heartsFlashTime = 0;
-    public int airSupply = 300;
-    private boolean firstTick = true;
     protected boolean fireImmune;
-    protected final @NotNull SynchedEntityData entityData = new SynchedEntityData();
+    public Block<?> activeFireBlock = Blocks.FIRE;
+
+    // Visual
     public float entityBrightness = 0.0F;
-    private double entityRiderPitchDelta;
-    private double entityRiderYawDelta;
+    public boolean ignoreFrustumCheck;
+
+    // Chunk
     public boolean addedToChunk = false;
     public int chunkCoordX;
     public int chunkCoordY;
     public int chunkCoordZ;
-    public int serverPosX;
-    public int serverPosY;
-    public int serverPosZ;
-    public boolean ignoreFrustumCheck;
-    public boolean isWalking = false;
-    protected boolean muteStepSounds = false;
+
+    // Speed
     public float speed;
     public float flySpeed;
+
+    // Walk
+    public boolean isWalking = false;
+    protected boolean muteStepSounds = false;
+    public float footSize = 0.0F;
+
+    // Tick
+    private boolean firstTick = true;
+    public int tickCount;
+
+    // Data
     public boolean sendAdditionalData = false;
-    public boolean turnWithVehicle = true;
+    protected final @NotNull SynchedEntityData entityData = new SynchedEntityData();
 
     public Entity(final @NotNull World world) {
         this.world = world;
@@ -270,7 +311,7 @@ public abstract class Entity
                     this.remainingFireTicks = 0;
                 }
             } else {
-                if (this.remainingFireTicks % 20 == 0) {
+                if (this.remainingFireTicks % FIRE_DAMAGE_INTERVAL_TICKS == 0) {
                     hurt(null, 1, DamageType.FIRE);
                 }
                 this.remainingFireTicks--;
@@ -348,17 +389,22 @@ public abstract class Entity
             hurt(null, 4, DamageType.FIRE);
             this.remainingFireTicks = 600;
             this.maxFireTicks = this.remainingFireTicks;
+            this.activeFireBlock = Blocks.FIRE;
         }
     }
 
-    public void fireHurt() {
+    public void fireHurt(Block<?> fireSource) {
         if (!this.fireImmune) {
             hurt(null, 1, DamageType.FIRE);
             this.remainingFireTicks = 300;
             this.maxFireTicks = this.remainingFireTicks;
+            this.activeFireBlock = fireSource;
         }
     }
 
+    public void fireHurt() {
+        this.fireHurt(Blocks.FIRE);
+    }
     public void outOfWorld() {
         remove();
     }
@@ -411,17 +457,19 @@ public abstract class Entity
 
             this.stuckInSpikes = false;
         }
+
         double oldXd = xd;
         double oldYd = yd;
         double oldZd = zd;
-        AABBd bbCopy = new AABBd(this.bb);
+        workingBox3.set(this.bb);
 
         double bbWidth = this.bb.maxX - this.bb.minX - 0.05;
         if (isSneaking()) { // Edge safety behavior
-            if (xd != 0.0) {
-                AABBd floor = new AABBd(this.bb.minX, this.bb.minY - 1.0, this.bb.minZ, this.bb.maxX, this.bb.minY, this.bb.maxZ);
-                MathHelper.aabbExpand(floor, xd, 0.0, 0.0, floor);
-                List<AABBdc> collidingBoxes = this.world.getCubes(this, floor);
+            if (zd != 0.0) {
+                workingBox1.setMin(this.bb.minX, this.bb.minY - 1.0, this.bb.minZ);
+                workingBox1.setMax(this.bb.maxX, this.bb.minY, this.bb.maxZ);
+                MathHelper.aabbExpand(workingBox1, 0.0, 0.0, zd, workingBox1);
+                List<AABBdc> collidingBoxes = this.world.getCubes(this, workingBox1);
                 if (!collidingBoxes.isEmpty()) {
                     double limitX = 0.0;
                     for (int i = 0; i < collidingBoxes.size(); i++) {
@@ -462,7 +510,18 @@ public abstract class Entity
             }
         }
 
-        List<AABBdc> cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, yd, zd, new AABBd()));
+        List<AABBdc> cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, yd, zd, workingBox2));
+        List<Entity> solidEntities = this.world.getEntitiesWithinAABBExcludingEntity(this, MathHelper.aabbExpand(this.bb, xd, yd, zd, workingBox2));
+
+        for (int i = 0; i < solidEntities.size(); i++) {
+            Entity solidEnt = solidEntities.get(i);
+
+            if (solidEnt.hasCollision() && solidEnt.getCollisionAABB() != null) {
+                if (this.collidesWith(solidEnt) && solidEnt.collidesWith(this)) {
+                    cubes.add(solidEnt.getCollisionAABB());
+                }
+            }
+        }
 
         // Check collision on Y Axis
         for (int i = 0; i < cubes.size(); i++) {
@@ -504,9 +563,11 @@ public abstract class Entity
             xd = oldXd;
             yd = this.footSize;
             zd = oldZd;
-            AABBd aabbCopy = new AABBd(this.bb);
-            this.bb.set(bbCopy);
-            cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, 0.0, zd, new AABBd()));
+
+            workingBox4.set(this.bb);
+
+            this.bb.set(workingBox3);
+            cubes = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, xd, 0.0, zd, workingBox2));
             for (int i = 0; i < cubes.size(); i++) {
                 yd = MathHelper.aabbClipYCollide(cubes.get(i), this.bb, yd);
             }
@@ -546,7 +607,7 @@ public abstract class Entity
                 xd = oldX;
                 yd = oldY;
                 zd = oldZ;
-                this.bb.set(aabbCopy);
+                this.bb.set(workingBox4);
             }
         }
         //fix for entity jitter when blasted by cannonballs (can cause some client-side jitter when entity is under a ceiling. unsure exactly why)
@@ -559,6 +620,7 @@ public abstract class Entity
         this.verticalCollision = oldYd != yd;
         this.onGround = oldYd != yd && oldYd < 0.0D;
         this.collision = this.horizontalCollision || this.verticalCollision;
+
         checkOnWater(false);
         checkFallDamage(yd, this.onGround);
         if (oldXd != xd) {
@@ -573,13 +635,13 @@ public abstract class Entity
         double d10 = this.x - d3;
         double d12 = this.z - d4;
         if (makeStepSound() && !isSneaking() && this.vehicle == null) {
-            this.walkDist += (double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6;
+            this.walkDist += (float) ((double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6);
 
-            // Tiny bounding box
-            AABBdc boundingBox = new AABBd(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
+            workingBox1.setMin(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01);
+            workingBox1.setMax(this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
 
             int blockX = MathHelper.floor(this.x);
-            int blockY = MathHelper.floor(boundingBox.minY());
+            int blockY = MathHelper.floor(workingBox1.minY());
             int blockZ = MathHelper.floor(this.z);
 
             Block<?> blockWalkedOn = null;
@@ -589,12 +651,9 @@ public abstract class Entity
                 for (int z = blockZ - 1; z <= blockZ + 1; z++) {
                     for (int y = blockY - 1; y < blockY + 1; y++) {
                         Block<?> block = this.world.getBlock(x, y, z);
-                        if (block == null) {
-                            continue;
-                        }
 
                         this.world.collidingBoundingBoxes.clear();
-                        block.getCollidingBoundingBoxes(this.world, x, y, z, boundingBox, this.world.collidingBoundingBoxes);
+                        block.getCollidingBoundingBoxes(this.world, x, y, z, workingBox1, this.world.collidingBoundingBoxes);
 
                         if (!this.world.collidingBoundingBoxes.isEmpty()) {
                             blockWalkedOn = block;
@@ -608,7 +667,7 @@ public abstract class Entity
             }
 
             // Check for snow layers
-            int blockYUp = MathHelper.floor(boundingBox.maxY());
+            int blockYUp = MathHelper.floor(workingBox1.maxY());
             Block<?> blockAbove = this.world.getBlock(blockX, blockYUp, blockZ);
             if (blockAbove != null && blockAbove.hasTag(BlockTags.OVERRIDE_STEPSOUND)) {
                 blockWalkedOn = blockAbove;
@@ -650,7 +709,7 @@ public abstract class Entity
 
         }
         boolean inWaterOrRain = isInWaterOrRain();
-        if (this.world.isBoundingBoxBurning(MathHelper.aabbInsetBoundingBox(this.bb, 0.001D, 0.001D, 0.001D, new AABBd()))) {
+        if (this.world.isBoundingBoxBurning(MathHelper.aabbInsetBoundingBox(this.bb, 0.001D, 0.001D, 0.001D, workingBox1))) {
             burn(1);
             if (!inWaterOrRain) {
                 this.remainingFireTicks++;
@@ -705,12 +764,17 @@ public abstract class Entity
         return null;
     }
 
-    protected void burn(int damage) {
+    protected void burn(int damage, Block<?> fireSource) {
         if (!this.fireImmune) {
             hurt(null, damage, DamageType.FIRE);
+            this.activeFireBlock = fireSource;
         }
     }
 
+    protected void burn(int damage) {
+        this.burn(damage, this.activeFireBlock != null ? this.activeFireBlock : Blocks.FIRE);
+    }
+
     protected void causeFallDamage(float distance) {
         if (this.passenger != null) {
             this.passenger.causeFallDamage(distance);
@@ -725,17 +789,78 @@ public abstract class Entity
         return this.wasInWater;
     }
 
+    public boolean isInAcid() {
+        return this.world.isMaterialInBB(this.bb, Materials.ACID);
+    }
+
+
+    public boolean isBoundingBoxIntersectingBlock(final @NotNull Block<?> target) {
+        return isAabbIntersectingBlock(this.bb, target);
+    }
+
+    public boolean isBoundingBoxIntersectingBlockTag(final @NotNull Tag<Block<?>> tag) {
+        return isAabbIntersectingBlockTag(this.bb, tag);
+    }
+
+    private boolean isAabbIntersectingBlock(final @NotNull AABBdc queryBb, final @NotNull Block<?> target) {
+        final double inset = 0.001D;
+        final int minX = MathHelper.floor(queryBb.minX() + inset);
+        final int minY = MathHelper.floor(queryBb.minY() + inset);
+        final int minZ = MathHelper.floor(queryBb.minZ() + inset);
+        final int maxX = MathHelper.floor(queryBb.maxX() - inset);
+        final int maxY = MathHelper.floor(queryBb.maxY() - inset);
+        final int maxZ = MathHelper.floor(queryBb.maxZ() - inset);
+        if (!this.world.areBlocksLoaded(minX, minY, minZ, maxX, maxY, maxZ)) {
+            return false;
+        }
+        final TilePos p = new TilePos();
+        for (p.x = minX; p.x <= maxX; p.x++) {
+            for (p.y = minY; p.y <= maxY; p.y++) {
+                for (p.z = minZ; p.z <= maxZ; p.z++) {
+                    if (this.world.getBlockType(p) == target) {
+                        return true;
+                    }
+                }
+            }
+        }
+        return false;
+    }
+
+    private boolean isAabbIntersectingBlockTag(final @NotNull AABBdc queryBb, final @NotNull Tag<Block<?>> tag) {
+        final double inset = 0.001D;
+        final int minX = MathHelper.floor(queryBb.minX() + inset);
+        final int minY = MathHelper.floor(queryBb.minY() + inset);
+        final int minZ = MathHelper.floor(queryBb.minZ() + inset);
+        final int maxX = MathHelper.floor(queryBb.maxX() - inset);
+        final int maxY = MathHelper.floor(queryBb.maxY() - inset);
+        final int maxZ = MathHelper.floor(queryBb.maxZ() - inset);
+        if (!this.world.areBlocksLoaded(minX, minY, minZ, maxX, maxY, maxZ)) {
+            return false;
+        }
+        final TilePos p = new TilePos();
+        for (p.x = minX; p.x <= maxX; p.x++) {
+            for (p.y = minY; p.y <= maxY; p.y++) {
+                for (p.z = minZ; p.z <= maxZ; p.z++) {
+                    if (Blocks.hasTag(this.world.getBlockType(p), tag)) {
+                        return true;
+                    }
+                }
+            }
+        }
+        return false;
+    }
+
     public boolean checkAndHandleWater(boolean addVelocity) {
         return this.world.handleMaterialAcceleration(MathHelper.aabbInsetBoundingBox(this.bb/*.expand(0.0D, -0.4D, 0.0D)*/, 0.001D, 0.001D, 0.001D, new AABBd()), Materials.WATER, this, addVelocity);
     }
 
     public boolean isUnderLiquid(@NotNull Material material) {
         double headY = this.y + (double) getHeadHeight();
-        TilePos tilePos = new TilePos(this.x, headY, this.z);
-        Block<?> block = this.world.getBlockType(tilePos);
-        if (block != null && block.getMaterial() == material) {
-            float f = BlockLogicFluid.getHeight(this.world.getBlockData(tilePos)) - 0.2F;
-            float f1 = (float) (tilePos.y + 1) - f;
+        workingPos1.set(this.x, headY, this.z);
+        Block<?> block = this.world.getBlockType(workingPos1);
+        if (block.getMaterial() == material) {
+            float f = BlockLogicFluid.getHeight(this.world.getBlockData(workingPos1)) - 0.2F;
+            float f1 = (float) (workingPos1.y + 1) - f;
             return headY < (double) f1;
         } else {
             return false;
@@ -887,18 +1012,23 @@ public abstract class Entity
         return !(this.pushTime > 0.5f) || !((this.xd * this.xd + this.yd * this.yd + this.zd * this.zd) > 1) || !Block.hasLogicClass(block, BlockLogicPistonHead.class); // TODO horrible hardcoded exception to getting stuck in piston heads during flings
     }
 
-    public void push(Entity entity) {
+    public void push(@NotNull Entity entity) {
         if (entity.passenger == this || entity.vehicle == this || entity.noPhysics || !entity.isPickable() || !this.collidesWith(entity) || !entity.collidesWith(this)) {
             return;
         }
+
+        if (this.bb.minY >= entity.bb.maxY - 0.25D || entity.bb.minY >= this.bb.maxY - 0.25D) {
+            return;
+        }
+
         double d = entity.x - this.x;
         double d1 = entity.z - this.z;
-        double d2 = MathHelper.abs_max(d, d1);
-        if (d2 >= 0.01D) {
-            d2 = MathHelper.sqrt(d2);
-            d /= d2;
-            d1 /= d2;
-            double d3 = 1.0D / d2;
+        double distSq = d * d + d1 * d1;
+        if (distSq >= 0.0001D) {
+            double dist = MathHelper.sqrt(distSq);
+            d /= dist;
+            d1 /= dist;
+            double d3 = 1.0D / dist;
             if (d3 > 1.0D) {
                 d3 = 1.0D;
             }
@@ -940,6 +1070,10 @@ public abstract class Entity
         return false;
     }
 
+    public boolean hasCollision() {
+        return false;
+    }
+
     public void awardKillScore(Entity entity, int i) {
     }
 
@@ -952,8 +1086,8 @@ public abstract class Entity
     }
 
     public boolean shouldRenderAtSqrDistance(final double distance, final double viewDistanceModifier) {
-        double d1 = MathHelper.getAABBSize(this.bb);
-        d1 *= 64D * this.viewScale * viewDistanceModifier;
+        double d1 = (this.bbWidth * 2.0F + this.bbHeight) / 3.0F;
+        d1 *= 64.0D * this.viewScale * viewDistanceModifier;
         return distance < d1 * d1;
     }
 
@@ -1070,10 +1204,13 @@ public abstract class Entity
     }
 
     public boolean isInWall() {
+        float widthOffset = this.bbWidth * 0.45F;
+        float heightOffset = 0.05F;
+
         for (int i = 0; i < 8; i++) {
-            float f = ((float) ((i >> 0) % 2) - 0.5F) * this.bbWidth * 0.9F;
-            float f1 = ((float) ((i >> 1) % 2) - 0.5F) * 0.1F;
-            float f2 = ((float) ((i >> 2) % 2) - 0.5F) * this.bbWidth * 0.9F;
+            float f = (i & 1) == 0 ? -widthOffset : widthOffset;
+            float f1 = (i & 2) == 0 ? -heightOffset : heightOffset;
+            float f2 = (i & 4) == 0 ? -widthOffset : widthOffset;
             int x = MathHelper.floor(this.x + (double) f);
             int y = MathHelper.floor(this.y + (double) getHeadHeight() + (double) f1);
             int z = MathHelper.floor(this.z + (double) f2);
@@ -1181,7 +1318,7 @@ public abstract class Entity
                        float xRot, int i) {
         setPos(x, y, z);
         setRot(yRot, xRot);
-        List<AABBdc> cubes = this.world.getCubes(this, MathHelper.aabbInsetBoundingBox(this.bb, 0.03125D, 0.0D, 0.03125D, new AABBd()));
+        List<AABBdc> cubes = this.world.getCubes(this, MathHelper.aabbInsetBoundingBox(this.bb, 0.03125D, 0.0D, 0.03125D, workingBox1));
         if (!cubes.isEmpty()) {
             double d3 = 0.0D;
             for (AABBdc cube : cubes) {
@@ -1276,35 +1413,35 @@ public abstract class Entity
     }
 
     protected boolean checkAndPushInTile(double x, double y, double z) {
-        TilePosc tilePos = new TilePos(x, y, z);
-        TilePos queryPos = new TilePos();
-        double depthX = x - (double) tilePos.x();
-        double depthY = y - (double) tilePos.y();
-        double depthZ = z - (double) tilePos.z();
-        if (this.world.isBlockNormalCube(tilePos)) {
+        workingPos1.set(x, y, z);
+        double depthX = x - (double) workingPos1.x();
+        double depthY = y - (double) workingPos1.y();
+        double depthZ = z - (double) workingPos1.z();
+
+        if (this.world.isBlockNormalCube(workingPos1)) {
             Direction direction = Direction.NONE;
             double minDepth = Double.MAX_VALUE;
-            if (depthX < minDepth && !this.world.isBlockNormalCube(tilePos.west(queryPos))) {
+            if (depthX < minDepth && !this.world.isBlockNormalCube(workingPos1.west(workingPos2))) {
                 minDepth = depthX;
                 direction = Direction.WEST;
             }
-            if (1.0D - depthX < minDepth && !this.world.isBlockNormalCube(tilePos.east(queryPos))) {
+            if (1.0D - depthX < minDepth && !this.world.isBlockNormalCube(workingPos1.east(workingPos2))) {
                 minDepth = 1.0D - depthX;
                 direction = Direction.EAST;
             }
-            if (depthY < minDepth && !this.world.isBlockNormalCube(tilePos.down(queryPos))) {
+            if (depthY < minDepth && !this.world.isBlockNormalCube(workingPos1.down(workingPos2))) {
                 minDepth = depthY;
                 direction = Direction.DOWN;
             }
-            if (1.0D - depthY < minDepth && !this.world.isBlockNormalCube(tilePos.up(queryPos))) {
+            if (1.0D - depthY < minDepth && !this.world.isBlockNormalCube(workingPos1.up(workingPos2))) {
                 minDepth = 1.0D - depthY;
                 direction = Direction.UP;
             }
-            if (depthZ < minDepth && !this.world.isBlockNormalCube(tilePos.north(queryPos))) {
+            if (depthZ < minDepth && !this.world.isBlockNormalCube(workingPos1.north(workingPos2))) {
                 minDepth = depthZ;
                 direction = Direction.NORTH;
             }
-            if (1.0D - depthZ < minDepth && !this.world.isBlockNormalCube(tilePos.south(queryPos))) {
+            if (1.0D - depthZ < minDepth && !this.world.isBlockNormalCube(workingPos1.south(workingPos2))) {
 //                minDepth = 1.0D - depthZ;
                 direction = Direction.SOUTH;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index ea20d7f3c..3eed062cb 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -391,6 +391,7 @@ public final class EntityDispatcher
             addMapping(MobChicken.class, "Chicken", 93);
             addMapping(MobSquid.class, "Squid", 94);
             addMapping(MobWolf.class, "Wolf", 95);
+            addMapping(ProjectileArrowFlaming.class, "FlamingArrow", 96);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java
new file mode 100644
index 000000000..4cd2339ae
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java
@@ -0,0 +1,59 @@
+package net.minecraft.core.entity;
+
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+import net.minecraft.core.util.helper.MathHelper;
+
+public class EntityItemHoming extends EntityItem {
+    private Entity target;
+    private int homingTicks;
+
+    public EntityItemHoming(World world, double x, double y, double z, ItemStack itemStack, Entity target) {
+        super(world, x, y, z, itemStack);
+        this.target = target;
+        this.homingTicks = 0;
+        this.pickupDelay = 20;
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+
+        this.homingTicks++;
+
+        if (this.target != null && !this.target.removed) {
+            double dX = this.target.x - this.x;
+            double dY = (this.target.y + (this.target.bbHeight / 2.0D)) - this.y;
+            double dZ = this.target.z - this.z;
+            double distance = MathHelper.sqrt(dX * dX + dY * dY + dZ * dZ);
+
+            if (distance < 64.0D && distance > 0.1D) {
+                double acceleration = Math.min(0.5D, 0.02D + (this.homingTicks * 0.01D));
+
+                double noiseX = (this.random.nextFloat() - 0.5D) * 0.2D;
+                double noiseY = (this.random.nextFloat() - 0.5D) * 0.2D;
+                double noiseZ = (this.random.nextFloat() - 0.5D) * 0.2D;
+
+                this.xd += ((dX / distance) + noiseX) * acceleration;
+                this.yd += ((dY / distance) + noiseY) * acceleration;
+                this.zd += ((dZ / distance) + noiseZ) * acceleration;
+
+                double antiGravity = Math.min(0.02D, this.homingTicks * 0.002D);
+                this.yd += antiGravity;
+
+                double currentSpeed = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
+                double maxSpeed = Math.min(1.2D, 0.2D + (this.homingTicks * 0.05D));
+
+                if (currentSpeed > maxSpeed) {
+                    this.xd = (this.xd / currentSpeed) * maxSpeed;
+                    this.yd = (this.yd / currentSpeed) * maxSpeed;
+                    this.zd = (this.zd / currentSpeed) * maxSpeed;
+                }
+
+                if (this.homingTicks > 10) {
+                    this.noPhysics = true;
+                }
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java b/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java
index 2964241b9..31e196982 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/IArmorWearing.java
@@ -24,8 +24,7 @@ public interface IArmorWearing<T extends IArmorShape> {
         for (int i = 0; i < getNumArmorSlots(); i++) {
             final @NotNull T armorSlot = Objects.requireNonNull(getArmorSlotByIndex(i));
             final @Nullable ItemStack armorItem = getItemInArmorSlot(armorSlot);
-            if (armorItem != null && armorItem.getItem() instanceof IArmorItem<?>) {
-                final @NotNull IArmorItem<?> armor = (IArmorItem<?>) armorItem.getItem();
+            if (armorItem != null && armorItem.getItem() instanceof @NotNull IArmorItem<?> armor) {
                 final @Nullable ArmorMaterial material = armor.getArmorMaterial();
                 if (material != null) {
                     protectionPercentage += material.getProtection(damageType) * armor.getArmorPieceProtectionPercentage();
@@ -38,8 +37,7 @@ public interface IArmorWearing<T extends IArmorShape> {
 
     default void damageArmor(final int damage, final @NotNull T armorSlot) {
         final @Nullable ItemStack armorItem = getItemInArmorSlot(armorSlot);
-        if (armorItem != null && armorItem.getItem() instanceof IArmorItem<?>) {
-            final @NotNull IArmorItem<?> armor = (IArmorItem<?>) armorItem.getItem();
+        if (armorItem != null && armorItem.getItem() instanceof @NotNull IArmorItem<?> armor) {
             final @Nullable ArmorMaterial material = armor.getArmorMaterial();
             if (material != null) {
                 if (this instanceof Entity) {
